<?php

namespace Drp\NativeEventApp\Auth;

use Laravel\Passport\Bridge\AuthCode;
use League\OAuth2\Server\ResponseTypes\AbstractResponseType;
use Psr\Http\Message\ResponseInterface;
use Zend\Diactoros\Response\TextResponse;

class AuthTokenResponse extends AbstractResponseType
{
    /** @var AuthCode */
    private $authCode;

    public function __construct(AuthCode $authCode)
    {
        $this->authCode = $authCode;
    }

    //phpcs:ignore
    public function generateHttpResponse(ResponseInterface $response): TextResponse
    {
        return new TextResponse($this->authCode->getIdentifier());
    }
}
