<?php

namespace Drp\NativeEventApp\GraphQL\Mutations;

use Drp\NativeEventApp\ArrayKeys;
use Drp\NativeEventApp\Exceptions\UserCouldNotBeAuthenticated;
use GraphQL\Type\Definition\ResolveInfo;
use League\OAuth2\Server\Exception\OAuthServerException;
use Nuwave\Lighthouse\Support\Contracts\GraphQLContext;

class Token extends BaseAuthResolver
{
    //phpcs:ignore
    public function __invoke($rootValue, array $args, ?GraphQLContext $context = null, ResolveInfo $resolveInfo): array
    {
        try {
            $request = $this->buildTokenRequest(ArrayKeys::snake($args), 'authorization_token');

            return $this->getResponse($request);
        } catch (OAuthServerException $exception) {
            throw new UserCouldNotBeAuthenticated(
                $exception->getMessage(),
                $exception->getHttpStatusCode(),
                $exception
            );
        }
    }
}
