<?php

namespace Drp\NativeEventApp\GraphQL\Resolvers;

use Drp\NativeEventApp\Auth\Facades\AuthInfoFinder;
use Drp\NativeEventApp\Models\Event;
use Drp\NativeEventApp\Models\Registration;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;

class PagesResolver
{
    public function __invoke(Event $event, array $args): Collection
    {
        $authenticatable = AuthInfoFinder::current();
        /** @var Registration $registration */
        $registration = Registration::forEventAndAuthenticatable($event, $authenticatable)->first();

        $pages = $event->pages();

        return $pages->viewableBy($registration)
            ->when(Arr::get($args, 'id', false), function ($query, $id) {
                return $query->where('id', $id);
            })
            ->get();
    }
}
