<?php

namespace Drp\NativeEventApp\Models;

use Drp\NativeEventApp\Quiz\QuizOperatorProxy;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @property-read QuizOperatorProxy $operator
 */
class Quiz extends Model
{
    /** @var string  */
    protected $table = 'quizzes';

    public function event(): BelongsTo
    {
        return $this->belongsTo(Event::class, 'eventId');
    }

    public function questions(): HasMany
    {
        return $this->hasMany(QuizQuestion::class, 'quizId');
    }

    public function getOperatorAttribute(): QuizOperatorProxy
    {
        return new QuizOperatorProxy($this);
    }
}
