<?php

namespace Drp\NativeEventApp\Modules;

use Illuminate\Support\Str;

trait HasAttributes
{
    public function __isset(string $attribute): bool
    {
        $value = $this->getAttribute($attribute);

        return isset($value);
    }

    /**
     * @return mixed
     */
    private function getAttribute(string $attribute)
    {
        if ($this->hasGetMutator($attribute)) {
            return $this->mutateAttribute($attribute);
        }

        return null;
    }

    public function hasGetMutator(string $attribute): bool
    {
        return method_exists($this, 'get' . Str::studly($attribute));
    }

    /**
     * @return mixed
     */
    protected function mutateAttribute(string $attribute)
    {
        return $this->{'get' . Str::studly($attribute)}();
    }

    /**
     * @return mixed
     */
    public function __get(string $attribute)
    {
        return $this->getAttribute($attribute);
    }
}
