<?php

namespace Drp\NativeEventApp\Test\Support\Fakes;

use Drp\NativeEventApp\Auth\ContactDetails;
use Drp\NativeEventApp\Auth\HasAuthMethods;
use Drp\NativeEventApp\Contracts\TokenAuthenticatable;
use Drp\NativeEventApp\Enums\AuthMethod;
use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Collection;

class Delegate implements TokenAuthenticatable, Authenticatable
{
    use HasAuthMethods, Notifiable;

    /** @var string */
    public $email = 'test@example.com';

    /** @var string  */
    public $phone = '07725854777';

    /** @var Collection */
    public $events;

    public function setEvents(Collection $events): self
    {
        $this->events = $events;

        return $this;
    }

    public function contactDetails(): ContactDetails
    {
        return ContactDetails::make()
            ->add(AuthMethod::SMS(), $this->phone)
            ->add(AuthMethod::EMAIL(), $this->email);
    }

    public function getId(): string
    {
        return '1';
    }

    public function getMinimumVersion(): int
    {
        return 1;
    }

    public function getKey()
    {
    }

    public function newQuery(): self
    {
        return $this;
    }

    public function where(): self
    {
        return $this;
    }

    public function first(): self
    {
        return $this;
    }

    public function getEvents(): Collection
    {
        return $this->events;
    }

    /**
     * @inheritDoc
     */
    public function getAuthIdentifierName()
    {
        return '';
    }

    /**
     * @inheritDoc
     */
    public function getAuthIdentifier()
    {
        return 1;
    }

    /**
     * @inheritDoc
     */
    public function getAuthPassword()
    {
        return 'password';
    }

    /**
     * @inheritDoc
     */
    public function getRememberToken()
    {
        return 'token';
    }

    /**
     * @inheritDoc
     */
    public function setRememberToken($value)
    {
        return 'remember_token';
    }

    /**
     * @inheritDoc
     */
    public function getRememberTokenName()
    {
        return 'remember_token_name';
    }
}
