<?php

use Drp\NativeEventApp\Migrations\TableMigration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateQuizAnswersTable extends TableMigration
{
    public function tableName(): string
    {
        return 'quiz_answers';
    }

    public function up(): void
    {
        Schema::create($this->getTableNameWithPrefix(), static function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->unsignedInteger('quizQuestionId')->references('id')->on('nea_quiz_questions');
            $table->string('title');
            $table->string('value');
            $table->text('image');
            $table->boolean('isCorrect')->default(0);
            $table->timestamps();
        });
    }

    public function down(): void
    {
        Schema::drop($this->getTableNameWithPrefix());
    }
}
