<?php

use Drp\NativeEventApp\Migrations\TableMigration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateQuizQuestionsTable extends TableMigration
{
    public function tableName(): string
    {
        return 'quiz_questions';
    }

    public function up(): void
    {
        Schema::create($this->getTableNameWithPrefix(), static function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->unsignedInteger('quizId')->references('id')->on('nea_quizzes');
            $table->string('title');
            $table->text('image');
            $table->string('type');
            $table->boolean('showCorrect')->default(0);
            $table->timestamps();
        });
    }

    public function down(): void
    {
        Schema::drop($this->getTableNameWithPrefix());
    }
}
